define(function(require, exports, module) {
	
    var MENU = function() {
        var _self = this;
        var tpl = '<div class="g-menuList" id="menuList">'
        		+ '<ul>'
        		+ '<li id="editName"><a href="javascript:;" class="edit-name">修改名称</a></li>'
        		+ '<li id="shareDevices"><a href="javascript:;" class="share-devices">分享控制权</a></li>'
        		+ '<li id="devicesDetails"><a page="deviceDetails" href="javascript:;" class="devices-details">设备详情</a></li>'
        		+ '<li id="removeDevices"><a href="javascript:;" class="remove-devices">删除设备</a></li>'
        		+ '</ul>'
        		+ '</div>';
        _self.options = {};

        //添加dom
        function setHtml(container) {
            _self.options['container'] = $(container);
            if (_self.options['container'].find('.g-menuList').length === 0) {
                _self.options['container'].append(tpl);
                _self.options['menuList'] = _self.options.container.find('.g-menuList');
                // _self.options['editName'] = _self.options.container.find('#editName');
                // _self.options['shareDevices'] = _self.options.container.find('#shareDevices');
                // _self.options['devicesDetails'] = _self.options.container.find('#devicesDetails');
                // _self.options['removeDevices'] = _self.options.container.find('#removeDevices');
            }
            bindEvent();
        }

        //监听
        function bindEvent() {
            /*_self.options.menuList.find('li').on('click', function(event) {
                if (_self.options.flag) {
                    getAlert($(this));
                }
            });*/
        }

        //显示菜单
        function show(e) {
            if (_self.options.menuList) {
                _self.options.menuList.addClass('show').removeClass('hide');
                e.attr('data-load', '0');
                _self.options['flag'] = true;
            }
        };

        //获取sign
        /*var signStr;
        function getSign(callback){
        	if(!signStr){
        		var signParam = {
        			"userId": userId,
                    "deviceId": deviceId,
                    "mcId": mcId
            	};
        		signParam = JSON.stringify(signParam);
        		getData.gGetSign('?params='+signParam,function(result){
            		if(result.ret === "0" && callback && typeof(callback) === "function"){
            			signStr = result.data;
            	        callback(signStr);
            		}
            	});
        	}else{
        		if (callback && typeof(callback) === "function") {
                    callback(signStr);
                }
        	}

        }*/

        //报错提示
        function gErrorTips(str){
        	var html='<div class="g-e-tips"><p>'+str+'</p></div>';
        	if( $(".g-e-tips").length ==0 ){
        		$("body").append( html );
        	}else{
        		$(".g-e-tips").find("p").html(str);
        	}
        	setTimeout(function(){
        		$(".g-e-tips").remove();
        	},1000);
        }

        //隐藏菜单
        function hide(e) {
            _self.options.menuList.addClass('hide');
            e.removeAttr('data-load');
           _self.options['flag'] = false;
        };

        //菜单列表Handler
        function getAlert(e) {
            var e = e[0];
            require.async(['./util/alert/sweetalert.min', '../css/sweetalert.css'], function(sweetalert) {
                switch (e.id) {
                    case 'editName': //修改名称
                        var gMcName = gFuncObj.gMcName;
                    	sweetalert({
                            title: "修改名称",
                            type: "input",
                            showCancelButton: true,
                            closeOnConfirm: true,
                            customClass: 'editName',
                            inputClass: 'iEditName',
                            inputClear: true,
                            inputValue:gMcName,
                            inputPlaceholder: "请输入设备名称"
                        }, function(inputValue) {
                            if (inputValue === false) return false;
                            if (inputValue === "") {
                                gFuncObj.gErrorTips("设备名称不能为空!");
                                return false;
                            }

                            gFuncObj.gMcName = inputValue;

                            var param = {
                                "userId": userId,
                                "mcId": mcId,
                                "mcAlias": inputValue,
                                "modelType":"1"
                            };
                            //alert(inputValue);
                            getData.gModifyMcName(param,function(data){    //{"deviceId":"","nickName":""}
                                var $mcName = $('#mcName');
                                var msg;
                                if(data.ret === "0"){
                                	$mcName.html(gFuncObj.gMcName);
                                	msg = "设备名称修改成功！";
                                }else{
                                	msg = "设备名称修改失败，请重新修改！";
                                }
                                gFuncObj.gErrorTips(msg);

                            });

                        });
                        break;
                    case 'shareDevices': //分享控制权
                    	if(isApp){
                    		var param='{"mcId":'+modId+'}';
                    		try{
                    			//alert("主动请求状态2");
                    			//alert(java2js);
                    			javascript:android.js2java("shareControl",param);
                    		} catch (e){}

                    	}else{
                    		require.async('./util/qrcode/qrcode', function(QRCODE) {

                    			var signParam = userId+ modelId + mcId;

                        		getData.gEncrypt( userId , signParam ,function(encrypt){

                                    	var url = host + '/api/device/jsonp/generateQRData'+'?userId=' + userId + '&userName=' + userName + '&deviceId=' + deviceId + '&mcId=' + mcId + '&modelId=' + modelId
                            			+ '&bindFlag=0&sign=' + encrypt;

                                    	$.ajax({
                                            type: "GET",
                                            url: url,
                                            dataType: "jsonp",
                                            async: false,
                                            timeout: 20000,
                                            success: function(data) {
                                            	if(data.ret=="0"){
                                            		var picCode=data.data;
                                            		if(picCode){
                                            			var qrcodeHtml = '<div id="qrcode" class="qrcode"></div>';

                                                        sweetalert({
                                                            title: "分享控制权",
                                                            text: qrcodeHtml + "<span>点击&quot;+&quot;添加设备，扫描此二维码，即可自动添加此设备</span>",
                                                            html: true
                                                        });

                                                        QRCODE.qrcode($('#' + $(qrcodeHtml)[0].id), {
                                                            width: 305,
                                                            height: 305,
                                                            correctLevel: QRCODE.QRErrorCorrectLevel.L,
                                                            background: "#ffffff",
                                                            foreground: "#000000",
                                                            text: picCode
                                                        });
                                            		}
                                            	};
                                            },
                                            error: function(XMLHttpRequest, textStatus, errorThrown) {
                                            	console.log('textStatus='+textStatus);
                                            	console.log('errorThrown='+errorThrown);
                                            }
                                        });
                        		});


                            });
                    	}
                        break;
                    case 'devicesDetails': //设备详情
                    	var param = {
                            "userId": userId,
                            "mcId": mcId
	                    };
                    	getData.gQueryMcInfo(param,function(result){
                            var data = result.data;
                            if(result.ret === "0"){
                            	require.async('./details', function(DDetails) {
                                    DDetails.setHtml('#content').handleData(data);
                                });
                            }else{
                            	swal(result.msg);
                            }
                        });

                        history.pushState({title: 'details'}, '', '?page=details');
                    	localStorage.setItem("title","details");

                        break;
                    case 'removeDevices': //删除设备
                        sweetalert({
                            title: "确定删除设备吗？",
                            showCancelButton: true,
                            confirmButtonText: "确定",
                            cancelButtonText: "取消",
                            closeOnConfirm: true
                        }, function() {
                        	if(isApp){
                        		var param = {
                                      "mcId": mcId,
                                      "modelType":"1"
                    			};
                        		getData.gUnbindMc(param,function(data){
                        			//console.log(data);
                        			var msg;
									if(data.ret === "0"){
										msg= "删除成功！";
									}else{
										msg= "删除失败！";
									}
									gFuncObj.gErrorTips(msg);
								});
                        	}else{
                        		var param = {
                                        "userId": userId,
                                        "deviceId": deviceId,
                                        "mcId": mcId,
                      			};

                        		getData.gUnbindMc(param,function(data){
                        			//console.log(data)
                        			var msg;
									if(data.ret === "0"){
										gFuncObj.gErrorTips("删除成功！");
										setTimeout(function() {
											location.href="../../home.html?userId="+userId;
							            }, 1200);
									}else{
										gFuncObj.gErrorTips("删除失败！");
									}
								});
                        	}
                        });
                        break;
                    default:
                        break;
                }
            });
        }

        return {
            setHtml: setHtml,
            show: show,
            hide: hide
        };

    };

    return MENU;
});
