define(function(require, exports, module) {
    require('../../../base/js/lib/zepto/zepto.min');
    var topMenu = new require('../../../base/js/topMenu')();
    var DevicesInit = function() {
        var _self = this;
        _self.options = {};
        var $menu = $('#menu');

        function init() {

            //首页回退
            $(".back-btn").on('click', function(e) {
                try {
                    javascript: android.js2java("finish", "");
                } catch (e) {
                    location.href = "../../home.html";
                }
            });

             /*总开关*/
            $('.switch1 a').on('click',function(){
                if($('.content').hasClass('bg-on')){    
                    //开机命令
                    location.href = "../lampblackMachine.html?state=off";

                    $('.content').removeClass('bg-on');     //关
                    $('.yyj-off').show();
                    $('.wind').hide();
                    $('.yyj-light').removeClass('yyj-light-on');
                    $('.menu-list li').removeClass('on');
                    $('.yyj-info').removeClass('fadeIn');
                }else{                                       //开
                    //开机命令
                    location.href = "../lampblackMachine.html?state=on";

                    $('.content').addClass('bg-on');
                    $('.yyj-off').hide();
                }
                
            });

            function xnLoad(state){
                if(xnFlag=="0"){
                    $('.content').addClass('bg-on');
                    $('.yyj-off').hide();
                }else if(xnFlag=="1"){
                    switchBtn = true;
                    $('.content').removeClass('bg-on');     //关
                    $('.yyj-off').show();
                    $('.wind').hide();
                    $('.yyj-light').removeClass('yyj-light-on');
                    $('.menu-list li').removeClass('on');
                    $('.yyj-info').removeClass('fadeIn');
                }
            }

            xnLoad(xnFlag);


            /*强弱档,照明,假日通风开关*/  
            $('.light-btn').on('click',function(){
                if($('.content').hasClass('bg-on')){
                    $('.yyj-light').toggleClass('yyj-light-on');
                    $(this).toggleClass('on');
                    
                 }else{
                    return false;
                 } 
            }); 
            $('.holiday-btn').on('click',function(){
                if($('.content').hasClass('bg-on')){
                    $('.yyj-info').toggleClass('fadeIn');
                    $(this).toggleClass('on');
                    
                 }else{
                    return false;
                 } 
            });
            $('.wind-btn').on('click',function(){
                if($('.content').hasClass('bg-on')){
                    $(this).toggleClass('on');
                    $(this).addClass('on').siblings('.wind-btn').removeClass('on');
                    var m = $(this).index();
                    $('.wind').eq(m).show().siblings('.wind').hide();
                }else{
                    return false;
                }
            });
            
             /*头部菜单*/
            topMenu.setHtml('#main');
            $menu.on('click', function(e) {
                var type = $(this).attr('data-load');
                if (!type) {
                    topMenu.show($(this));
                } else {
                    topMenu.hide($(this));
                }
                e.stopPropagation();
            });

            $('html').on('click', function(e) {
                var type = $menu.attr('data-load');
                if (type && isTouchScreen()) {
                    topMenu.hide($menu);
                }
            });
        }
        //判断是否Touch屏幕
        function isTouchScreen() {
            return (('ontouchstart' in window) || window.DocumentTouch && document instanceof DocumentTouch);
        }
        return {
            init: init
        };
    };

    return new DevicesInit;
});
