define(function(require, exports, module) {
    require('../../../base/js/lib/zepto/zepto.min');
    var topMenu = new require('../../../base/js/topMenu')();
    var centerShow = require('./centreShow');
    var getData = require('../../../base/js/getData');

    var menu = require('./menu');
    var dataFix = require('./../dataFix');
    //加载全局方法，提供IOS,android调用
    var gFunc = require('./gFunc');

    gFuncObj.gBootRequest = gFunc.gBootRequest;
    gFuncObj.java2js = gFunc.java2js;
    gFuncObj.gErrorTips = gFunc.gErrorTips;
    java2js = gFuncObj.java2js;


    
    
    window.cachedDeviceInfo = dataFix.deviceInfo;
    gFuncObj.gMcName = dataFix.deviceInfo.mcName;
    gFuncObj.deviceSwitch = dataFix.stateObj.deviceSwitch;

    var DevicesInit = function() {
        var _self = this;
        var $exitBtn = $('#exitBtn');
        _self.options = {};

        function init() {

            //头部菜单载入
            topMenu.setHtml('#main');

            //首页回退
            $exitBtn.on('click', function(e) {
                try {
                    javascript: android.js2java("finish", "");
                } catch (e) {
                    location.href = "../../home.html";
                }
            });


            //设备名称
            if (gFuncObj.gMcName) {
                $("#mcName").html(gFuncObj.gMcName);
            }

            //历史记录
            //history.pushState(null, '', '#bulb');
            localStorage.setItem("title", "bulb");

            //页面回退监控
            if (history.pushState) {
                window.addEventListener("popstate", function() {
                    //var currentState = history.state;
                    //var page = currentState.title;
                    var page = localStorage.getItem("title");
                    switch (page) {
                        case 'bulb':
                            require.async('../../../base/js/details', function(DDetails) {
                                //console.log(DDetails);
                                DDetails.animate(false);
                            });
                            break;
                        case 'details': //删除设备
                            require.async('../../../base/js/details', function(DDetails) {
                                DDetails.animate(true);
                            });
                            break;
                        case 'home':
                            break;
                        default:
                            break;
                    }
                });
            }

            //控制面板开关
            var $switch = $('#switch');
            var switchBtn = true;

            $switch.on('click', function(e) {
                if (switchBtn) {

                    switchBtn = false;

                    if (gFuncObj.deviceSwitch == "0") {

                        //开机命令
                        location.href = "../light.html?state=on";

                        switchBtn = true;
                        window.cachedstateObj.deviceSwitch = "1";
                        gFuncObj.deviceSwitch = "1";
                        $('#main').removeClass('main-gray');
                    } else if (gFuncObj.deviceSwitch == "1") {
                        //关机命令
                        location.href = "../light.html?state=off";

                        switchBtn = true;
                        gFuncObj.deviceSwitch = "0";
                        window.cachedstateObj.deviceSwitch = "0";
                        $('#main').addClass('main-gray');
                    }

                }
                try {
                    //sa.click.sendDatasIndex(this); //数据上报
                } catch (e) {}

            });


            function xnLoad(state){
                if(xnFlag=="0"){
                    switchBtn = true;
                    gFuncObj.deviceSwitch = "1";
                    $('#main').removeClass('main-gray');
                }else if(xnFlag=="1"){
                    switchBtn = true;
                    gFuncObj.deviceSwitch = "0";
                    $('#main').addClass('main-gray');
                }
            }

            xnLoad(xnFlag);

            //$switch.trigger("click");

            centerShow.createDom();
            menu.init(dataFix.stateObj);
        }

        return {
            init: init
        };
    };

    return new DevicesInit;
});
